execute as @s at @s if block ~ ~-1 ~ minecraft:obsidian run tag @s add bottom
execute as @s at @s if block ~ ~-1 ~ minecraft:crying_obsidian run tag @s add bottom

execute as @s at @s if block ~ ~1 ~ amethyst_block run tag @s add top
execute as @s at @s if block ~ ~1 ~ quartz_block run tag @s add top
execute as @s at @s if block ~ ~1 ~ emerald_block run tag @s add top

execute as @s at @s if block ~ ~2 ~ redstone_wire run tag @s add wire


execute as @s[tag=wire,tag=top,tag=bottom] at @s run summon minecraft:marker ~ ~ ~ {Tags:["teleporter"]}
execute as @s[tag=wire,tag=top,tag=bottom] at @s run title @a[distance=..10] actionbar {"text":"The teleporter is now online","color":"green"}

#add the ticking area and up the counter for number of actives
execute as @s[tag=wire,tag=top,tag=bottom] at @s run scoreboard players add _game_data te_count 1


#we need the current entity uniquely identitified this function teleporters:only runs for 1 entity per time per slow tick, so this is fine as long as we clean up.
execute as @s[tag=wire,tag=top,tag=bottom] at @s run tag @s add working_target

#because people can create and destroy ticking areas out of number order they were created in, we track areas available with flags in the key
scoreboard players operation @a te_tickareakey = _game_data te_tickareakey
scoreboard players operation @p te_workValue = _game_data te_tickareakey
scoreboard players operation @p te_workValue %= _game_data te_two

#add tickingarea 1 flag 
execute as @p[scores={te_workValue=0}] at @s run tag @e[tag=working_target] add tickarea1

scoreboard players operation @p te_tickareakey -= @p te_workValue
scoreboard players operation @p te_tickareakey /= _game_data te_two
scoreboard players operation @p te_workValue = @p te_tickareakey
scoreboard players operation @p te_workValue %= _game_data te_two

#add tickingarea 2 flag unless we already found a previous flag
execute as @p[scores={te_workValue=0}] at @s run tag @e[tag=working_target,tag=!tickarea1] add tickarea2

scoreboard players operation @p te_tickareakey -= @p te_workValue
scoreboard players operation @p te_tickareakey /= _game_data te_two
scoreboard players operation @p te_workValue = @p te_tickareakey
scoreboard players operation @p te_workValue %= _game_data te_two

execute as @p[scores={te_workValue=0}] at @s run tag @e[tag=working_target,tag=!tickarea1,tag=!tickarea2] add tickarea3

scoreboard players operation @p te_tickareakey -= @p te_workValue
scoreboard players operation @p te_tickareakey /= _game_data te_two
scoreboard players operation @p te_workValue = @p te_tickareakey
scoreboard players operation @p te_workValue %= _game_data te_two

execute as @p[scores={te_workValue=0}] at @s run tag @e[tag=working_target,tag=!tickarea1,tag=!tickarea2,tag=!tickarea3] add tickarea4

scoreboard players operation @p te_tickareakey -= @p te_workValue
scoreboard players operation @p te_tickareakey /= _game_data te_two
scoreboard players operation @p te_workValue = @p te_tickareakey
scoreboard players operation @p te_workValue %= _game_data te_two

execute as @p[scores={te_workValue=0}] at @s run tag @e[tag=working_target,tag=!tickarea1,tag=!tickarea2,tag=!tickarea3,tag=!tickarea4] add tickarea5

scoreboard players operation @p te_tickareakey -= @p te_workValue
scoreboard players operation @p te_tickareakey /= _game_data te_two
scoreboard players operation @p te_workValue = @p te_tickareakey
scoreboard players operation @p te_workValue %= _game_data te_two

execute as @p[scores={te_workValue=0}] at @s run tag @e[tag=working_target,tag=!tickarea1,tag=!tickarea2,tag=!tickarea3,tag=!tickarea4,tag=!tickarea5] add tickarea6

#forceload remove all
#forceload add ~-1 ~ ~-1 ~1 ~ ~1 tickarea1
#add the found ticking area and set the flag as in use
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea1] at @s run forceload add ~-1 ~-1 ~1 ~1 
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea1] at @s run scoreboard players add _game_data te_tickareakey 1
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea1] at @s run tag @e[type=minecraft:marker,tag=!checker,distance=..1,tag=!teleporter] add tickarea1

execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea2] at @s run forceload add ~-1 ~-1 ~1 ~1 
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea2] at @s run scoreboard players add _game_data te_tickareakey 2
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea2] at @s run tag @e[type=minecraft:marker,tag=!checker,distance=..1,tag=!teleporter] add tickarea2

execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea3] at @s run forceload add ~-1 ~-1 ~1 ~1 
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea3] at @s run scoreboard players add _game_data te_tickareakey 4
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea3] at @s run tag @e[type=minecraft:marker,tag=!checker,distance=..1,tag=!teleporter] add tickarea3

execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea4] at @s run forceload add ~-1 ~-1 ~1 ~1 
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea4] at @s run scoreboard players add _game_data te_tickareakey 8
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea4] at @s run tag @e[type=minecraft:marker,tag=!checker,distance=..1,tag=!teleporter] add tickarea4

execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea5] at @s run forceload add ~-1 ~-1 ~1 ~1 
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea5] at @s run scoreboard players add _game_data te_tickareakey 16
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea5] at @s run tag @e[type=minecraft:marker,tag=!checker,distance=..1,tag=!teleporter] add tickarea5

execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea6] at @s run forceload add ~-1 ~-1 ~1 ~1 
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea6] at @s run scoreboard players add _game_data te_tickareakey 32
execute as @s[tag=wire,tag=top,tag=bottom,tag=tickarea6] at @s run tag @e[type=minecraft:marker,tag=!checker,distance=..1,tag=!teleporter] add tickarea6


execute as @s at @s if block ~ ~-1 ~ minecraft:obsidian run tag @e[type=minecraft:marker,tag=!checker,distance=..1,tag=teleporter] add mob
execute as @s at @s if block ~ ~-1 ~ minecraft:crying_obsidian run tag @e[type=minecraft:marker,tag=!checker,distance=..1,tag=teleporter] add item

execute as @s at @s if block ~ ~1 ~ minecraft:amethyst_block run tag @e[type=minecraft:marker,distance=..1,tag=teleporter] add purple
execute as @s at @s if block ~ ~1 ~ minecraft:quartz_block run tag @e[type=minecraft:marker,distance=..1,tag=teleporter] add white
execute as @s at @s if block ~ ~1 ~ minecraft:emerald_block run tag @e[type=minecraft:marker,distance=..1,tag=teleporter] add green



tag @s remove top
tag @s remove bottom
tag @s remove wire
tag @s remove working_target
tag @s remove tickarea6
tag @s remove tickarea5
tag @s remove tickarea4
tag @s remove tickarea3
tag @s remove tickarea2
tag @s remove tickarea1