#this function teleporters:runs every 75 ticks - 3.75 seconds

#remove old entities waiting to be removed out of ear shot
kill @e[tag=killEnt]

#if a teleporter no longer has a copper block over it shut it down (but only check within 10 blocks.. otherwise, moving between dimensions will cause this to fail )
execute as @a at @s run tag @e[tag=teleporter,distance=..10] add copper
execute as @a at @s run execute as @e[tag=teleporter,distance=..10] at @s if block ~ ~ ~ minecraft:waxed_copper_block run tag @s remove copper
execute as @e[tag=copper,limit=1] at @s run title @a[distance=..10] actionbar {"text":"The teleporter is now offline","color":"#fa30fa"} 
execute as @e[tag=copper,limit=1] at @s run scoreboard players remove _game_data te_count 1

execute as @e[tag=copper,limit=1,tag=tickarea1] at @s run forceload remove ~-1 ~-1 ~1 ~1
execute as @e[tag=copper,limit=1,tag=tickarea1] at @s run scoreboard players remove _game_data te_tickareakey 1
execute as @e[tag=copper,limit=1,tag=tickarea2] at @s run forceload remove ~-1 ~-1 ~1 ~1
execute as @e[tag=copper,limit=1,tag=tickarea2] at @s run scoreboard players remove _game_data te_tickareakey 2
execute as @e[tag=copper,limit=1,tag=tickarea3] at @s run forceload remove ~-1 ~-1 ~1 ~1
execute as @e[tag=copper,limit=1,tag=tickarea3] at @s run scoreboard players remove _game_data te_tickareakey 4
execute as @e[tag=copper,limit=1,tag=tickarea4] at @s run forceload remove ~-1 ~-1 ~1 ~1
execute as @e[tag=copper,limit=1,tag=tickarea4] at @s run scoreboard players remove _game_data te_tickareakey 8
execute as @e[tag=copper,limit=1,tag=tickarea5] at @s run forceload remove ~-1 ~-1 ~1 ~1
execute as @e[tag=copper,limit=1,tag=tickarea5] at @s run scoreboard players remove _game_data te_tickareakey 16
execute as @e[tag=copper,limit=1,tag=tickarea6] at @s run forceload remove ~-1 ~-1 ~1 ~1
execute as @e[tag=copper,limit=1,tag=tickarea6] at @s run scoreboard players remove _game_data te_tickareakey 32

tp @e[tag=copper] ~ -65 ~
tag @e[tag=copper] add killEnt
tag @e[tag=copper] remove teleporter

#only allow 6 teleporters, we could just look at te_tickareakey and see that its value is under 64 but this is easier to understand
scoreboard players operation @a te_count = _game_data te_count
scoreboard players operation @a te_inprocess = _game_data te_inprocess

#run for every player at their location, if the last run hasn't finished. don't start it again.
execute as @a[scores={te_count=..5},limit=1] at @s run execute as @a[scores={te_inprocess=0}] at @s run function teleporters:teleporters/checkteleporter1 

#as a fail safe for a bug. if the last run still hasn't finished go head and flag it to run next time. it should be done by then or something bad happened and it's bugged out.
execute as @a[scores={te_inprocess=1..}] at @s run scoreboard players set _game_data te_inprocess 0


#run this every 125 ticks
scoreboard players set _game_data te_countDownSlow 5
